
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>详细解读Spark的数据分析引擎：Spark SQL / 憋错料</title>

    <meta name="description" content="详细解读Spark的数据分析引擎：Spark SQL 欢迎关注大数据和人工智能技术文章发布的微信公众号:清研学堂,在这里你可以学到夜白(作者笔名)精心整理的笔记,让我们每天进步一点点,让优秀成为一种习惯! 一.spark SQL:类似于Hive,是一种数据分析引擎 什么是spark SQL? spark SQL只能处理结构化数据 底层依赖RDD,把sql语句转换成一个个RDD,运行在不同的worker上 特点: 1.容易集成:SQL语句 2.对不同的数据源提供统一的访问方式:DataFrame 用DataFrame屏蔽数据源的差别 3.兼容Hive">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">详细解读Spark的数据分析引擎：Spark SQL</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>欢迎关注大数据和人工智能技术文章发布的微信公众号：清研学堂，在这里你可以学到夜白（作者笔名）精心整理的笔记，让我们每天进步一点点，让优秀成为一种习惯！</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcDMucHN0YXRwLmNvbS9sYXJnZS82NmFkMDAwMzlhMDBhNzA2ZGMyNg==.jpg"></p>
<p>一、spark SQL:类似于Hive，是一种数据分析引擎</p>
<p>什么是spark SQL？</p>
<p>spark SQL只能处理结构化数据</p>
<p>底层依赖RDD，把sql语句转换成一个个RDD，运行在不同的worker上</p>
<p>特点：</p>
<p>1、容易集成：SQL语句</p>
<p>2、对不同的数据源提供统一的访问方式：DataFrame 用DataFrame屏蔽数据源的差别</p>
<p>3、兼容Hive</p>
<p>大纲：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcDkucHN0YXRwLmNvbS9sYXJnZS82NmFlMDAwMzg4YTMxNTBmODE3YQ==.jpg"></p>
<p>核心概念：DataFrame（看作表）：就是表，是Spark SQL对结构化数据的抽象集合</p>
<p>表现形式：RDD</p>
<p>表=表结构+数据</p>
<p>DataFrame=schema+RDD</p>
<p>DataSet(新API接口 看作表)</p>
<p>如何创建DataFrame？</p>
<p>1、方式一：通过case class创建DataFrame</p>
<p>创建表结构</p>
<p>case class EMP(empno:Int,ename:String,job:String,mgr:String,hiredata:String,sal:Int,comm:String,deptno:Int)</p>
<p>导入emp.csv文件并指定分隔符</p>
<p>val lines = sc.textFile("/root/temp/emp.csv").map(_.split(","))</p>
<p>lines.collect</p>
<p>将表结构和数据关联起来</p>
<p>val allEmp = lines.map(x=&gt;Emp(x(0).toInt,x(1),x(2),x(3),x(4),x(5).toInt,x(6),x(7).toInt))</p>
<p>创建DataFrame:</p>
<p>val empDF = allEmp.toDF</p>
<p>操作DataFrame:</p>
<p>empDF.show：展示DataFrame</p>
<p>empDF.printSchema：打印DataFrame的表结构</p>
<p>2、方式二：通过SparkSession.createDataFrame()创建DataFrame</p>
<p>什么是spark session?</p>
<p>从spark2.0以后提供了统一访问spark各个模块的对象：spark session</p>
<p>创建表结构:用StructType类</p>
<p>import org.apache.spark.sql</p>
<p>import org.apache.spark.sql.types._</p>
<p>val myschema = StructType(List(empno:Int,ename:String,job:String,mgr:String,hiredata:String,sal:Int,comm:String,deptno:Int))</p>
<p>导入emp.csv文件并指定分隔符</p>
<p>val lines = sc.textFile("/root/temp/emp.csv").map(_.split(","))</p>
<p>将表结构和数据关联起来，把读入的数据emp.csv映射成一行，这里没有带表结构</p>
<p>import.org.apache.spark.sql._</p>
<p>val rowRDD = lines.map(x=&gt;Row(x(0).toInt,x(1),x(2),x(3),x(4),x(5).toInt,x(6),x(7).toInt))</p>
<p>通过SparkSession.createDataFrame()创建表</p>
<p>val df = spark.createDataFrame(rowRDD,myschema)</p>
<p>3、方式三：直接读取一个具有格式的数据文件作为DataFrame（json文件）</p>
<p>val peopleDF = spark.read.json("/root/training/")</p>
<p>4、操作DataFrame:DSL语句和SQL语句</p>
<p>DSL语句：empDF.show</p>
<p>empDF.printSchema</p>
<p>查询所有员工的信息：df.show</p>
<p>查询所有员工的姓名：df.select("ename").show</p>
<p>或者df.select($"ename").show</p>
<p>查询员工信息：姓名 薪水 薪水+100</p>
<p>df.select($"ename",$"sal",$"sal"+100).show</p>
<p>查询工资大于2000的员工</p>
<p>df.filter("sal"&gt;2000).show</p>
<p>分组：</p>
<p>df.groupBy("deptno").count.show</p>
<p>SQL语句：需要将DataFrame注册成一张临时视图</p>
<p>df.createOrReplaceTempView("emp")</p>
<p>spark.sql("select * from emp").show</p>
<p>spark.sql("select * from emp where deptno=10").show</p>
<p>5、临时视图：2种</p>
<p>1、只在当前会话中有效：临时视图 df.createOrReplaceTempView("emp")</p>
<p>2、在全局范围内都有效：全局临时视图 df.createGlobalTempView("empG")</p>
<p>例：在当前会话中</p>
<p>spark.sql("select * from emp").show</p>
<p>spark.sql("select * from global_temp.empG").show</p>
<p>例：在新的会话中</p>
<p>spark.newSession.sal("select * from emp").show</p>
<p>spark.newSession.sal("select * from global_temp.empG").show</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcDkucHN0YXRwLmNvbS9sYXJnZS82NmFhMDAwNWNmYjBkZjQxZGMxOQ==.jpg"></p>
<p>二、使用数据源：</p>
<p>1、load函数加载数据源和save函数保存数据源</p>
<p>load函数默认的数据源是parquet文件</p>
<p>json函数默认的数据源是json文件</p>
<p>val usersDF = spark.read.load("/root/training/spakr-2.1.0-bin-hadoop2.7/examples/")</p>
<p>usersDF.select("name","favorite_color").show</p>
<p>usersDF.select("name","favorite_color").write.save("/root/temp/result")</p>
<p>2、Parquet文件：是sparkSQL load函数默认加载的数据源，按列存储的文件</p>
<p>如何把其他文件格式转换成parquet文件？</p>
<p>例：json文件----&gt;parquet文件</p>
<p>val empJSON = spark.read.json("/root/temp/emp.json") #直接读取一个具有格式的数据文件作为DataFrame</p>
<p>empJSON.write.parquet("/root/temp/empparquet") #/empparquet目录不能事先存在</p>
<p>或者empJSON.wirte.mode("overwrite").parquet("/root/temp/result") #/result目录可以事先存在</p>
<p>功能：支持Schema的合并</p>
<p>第一个文件：val df1 = sc.makeRDD(1 to 5).map(i=&gt;(i,i*2)).toDF("single","double")</p>
<p>df1.write.parquet("/root/temp/test_table/key=1")</p>
<p>第二个文件：val df2 = sc.makeRD(6 to 10).map(i=&gt;(i,i*3)).toDF("single","triple")</p>
<p>df2.write.parquet("/root/temp/test_table/key=2")</p>
<p>合并两个文件：val df3 = spark.read.option("mergeSchema","true").parquet("/root/temp/test_table")</p>
<p>3、json文件：</p>
<p>spark.read.json("/root/training/spark-2.1.0-bin-hadoop-2.7/examples/src/main/resources/people.json")</p>
<p>spark.read.format("json").load("/root/training/spark-2.1.0-bin-hadoop2.7/examples/src/main/resources/people.json")</p>
<p>4、RDBMS：需要把RDBMS的驱动加入到spark shell中</p>
<p>spark.read.format("jdbc").option("url","jdbc:oracle:thin:@192.168.182.11:1521/orcl.example.com").option("dbtable","scott.emp").option("user","scott").option("password","tiger").load</p>
<p>或使用Properties类</p>
<p>import java.util.Properties</p>
<p>val prop = new Properties()</p>
<p>prop.setProperty("user","scott")</p>
<p>prop.setProperty("password","tiger")</p>
<p>val oracleDF1 = spark.read.jdbc("jdbc:oracle:thin:@192.168.182.11:1521/orcl")</p>
<p>作者：李金泽AllenLi，清华大学在读硕士，研究方向：大数据和人工智能</p>

<p>原文地址：https://www.cnblogs.com/lijinze-tsinghua/p/8505281.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-12 13:56:41 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/form/" title="form">form</a>, <a href="https://www.biecuoliao.com/tag/print/" title="print">print</a>, <a href="https://www.biecuoliao.com/tag/ase/" title="ase">ase</a>, <a href="https://www.biecuoliao.com/tag/body/" title="body">body</a>, <a href="https://www.biecuoliao.com/tag/%e4%bf%9d%e5%ad%98/" title="保存">保存</a>, <a href="https://www.biecuoliao.com/tag/%e5%85%bc%e5%ae%b9/" title="兼容">兼容</a>, <a href="https://www.biecuoliao.com/tag/result/" title="result">result</a>, <a href="https://www.biecuoliao.com/tag/worker/" title="worker">worker</a>, <a href="https://www.biecuoliao.com/tag/overwrite/" title="overwrite">overwrite</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>详细解读Spark的数据分析引擎：Spark SQL的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4poGxK3.html" rel="bookmark">《Spark大数据分析：核心概念、技术及实践》大数据技术一览</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节书摘来自华章出版社&lt;Spark大数据分析:核心概念.技术及实践&gt;一书中的第1章,第1节,作者穆罕默德·古勒(Mohammed Guller)更多章节内容可以访问云栖社区&quot;华章计算机&quot;公众号查看. 大数据技术一览 我们正处在大数据时代.数据不仅是任何组织的命脉,而且在指数级增长.今天所产生的数据比过去几年所产生的数据大好几个数量级.挑战在于如何从数据中获取商业价值.这就是大数据相关技术想要解决的问题.因此,大数据已成为过去几年最热门的技术趋势之一.一些非常活跃的开源项目都			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4A2DdzM.html" rel="bookmark">Cassandra联手Spark 大数据分析将迎来哪些改变？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2014Spark峰会在美国旧金山举行,与会数据库平台供应商DataStax宣布,与Spark供应商Databricks合作,在它的旗舰产 品 DataStax Enterprise 4.5 (DSE)中,将Cassandra NoSQL数据库与Apache Spark开源引擎相结合,为用户提供基于内存处理的实时分析. Databricks是一家由Apache Spark创始人成立的公司.谈到这次合作,DataStax副总裁John Glendenning表示:“将Spark与Cassandra			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41VEeXM.html" rel="bookmark">Azure HDInsight 和 Spark 大数据分析（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				What is HDInsight? Microsoft Azure HDInsight 是基于 Hortonoworks Data Platform (HDP) 的 Hadoop 集群,包括Storm, HBase, Pig, Hive, Sqoop, Oozie, Ambari等(具体的组件请参看最后的附录).Azure HDInsight 支持 Windows的集群部署,也支持 Linux 集群部署.Hortonworks 是我目前所知唯一支持在 Windows 上部署的 Hadoop C			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eWBmg4.html" rel="bookmark">Spark大数据分析框架的核心部件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spark大数据分析框架的核心部件 Spark大数据分析框架的核心部件包含RDD内存数据结构.Streaming流计算框架.GraphX图计算与网状数据挖掘.MLlib机器学习支持框架.Spark SQL数据检索语言.Tachyon文件系统.SparkR计算引擎等主要部件.这里做一个简单的介绍. 一.RDD内存数据结构 大数据分析系统一般包括数据获取.数据清洗.数据处理.数据分析.报表输出等子系统.Spark为了方便数据处理.提升性能,专门引入了RDD数据内存结构,这一点与R的机制非常类似.用户			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YVWja3.html" rel="bookmark">大数据学习：Spark是什么，如何用Spark进行数据分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				给大家分享一下Spark是什么?如何用Spark进行数据分析,对大数据感兴趣的小伙伴就随着小编一起来了解一下吧. 大数据在线学习 什么是Apache Spark? Apache Spark是一个为速度和通用目标设计的集群计算平台. 从速度的角度看,Spark从流行的MapReduce模型继承而来,可以更有效地支持多种类型的计算,如交互式查询和流处理.速度在大数据集的处理中非常重要,它可以决定用户可以交互式地处理数据,还是等几分钟甚至几小时.Spark为速度提供的一个重要特性是其可以在内存中运行计			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzoeaJ0.html" rel="bookmark">Python3实战Spark大数据分析及调度 （网盘分享）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Python3实战Spark大数据分析及调度 搜索QQ号直接加群获取其它学习资料:517432778 部分课程截图: 链接:https://pan.baidu.com/s/1YMmswv47fOUlt-z2A6691A 提取码:z5xv PS:免费分享,若点击链接无法获取到资料,若如若链接失效请加群 其它资源在群里,私聊管理员即可免费领取:群——517432778,点击加群,或扫描二维码   第1章 课程介绍 课程介绍 1-1 PySpark导学试看 1-2 OOTB环境演示 第2章 实战环境搭			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xYkQz3.html" rel="bookmark">容器开启数据服务之旅系列（二）：Kubernetes如何助力Spark大数据分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 容器开启数据服务之旅系列(二):Kubernetes如何助力Spark大数据分析 (二):Kubernetes如何助力Spark大数据分析 概述 本文为大家介绍一种容器化的数据服务Spark + OSS on ACK,允许Spark分布式计算节点对阿里云OSS对象存储的直接访问. 容器开启数据服务之旅系列(二):Kubernetes如何助力Spark大数据分析 (二):Kubernetes如何助力Spark大数据分析 概述 本文为大家介绍一种容器化的数据服务Spark + OSS on			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/387ZlW0.html" rel="bookmark">Spark 实践&mdash;&mdash;用Scala和Spark进行数据分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文基于&lt;Spark 高级数据分析&gt;第2章 用Scala和Spark进行数据分析. 完整代码见 https://github.com/libaoquan95/aasPractice/tree/master/c2/Into 1.获取数据集 数据集来自加州大学欧文分校机器学习资料库(UC Irvine Machine Learning Repository),这个资料库为研究和教学提供了大量非常好的数据源, 这些数据源非常有意义,并且是免费的. 我们要分析的数据集来源于一项记录关联研究,这项研究是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBKwDj0.html" rel="bookmark">引爆Spark大数据引擎的七大工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文名称:7 tools to fire up Spark's big data engine Spark正在数据处理领域卷起一场风暴.让我们通过本篇文章,看看为Spark的大数据平台起到推波助澜的几个重要工具. Spark生态系统众生相 Apache Spark不仅仅让大数据处理起来更快,还让大数据处理起来更简单.功能更强大.更方便.Spark并非只是一项技术,它结合了诸多部分,新的功能和性能改进不断添加进来,每个部分都在不断完善之中. 本文介绍了Spark生态系统的每个主要部分:每个部分的功			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41RrGM.html" rel="bookmark" class="title">通过网卡批量安装电脑系统</a>
					<div>
						需要服务:httpd,tftp,syslinux,system-config-kickstart,dhcp 1,配置ks.cfg文件 安装httpd服务,并将其打开 安装system-config-k ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQLzB3.html" rel="bookmark" class="title">Linux运维实战训练&mdash;&mdash;学员优秀作业评选</a>
					<div>
						8月27日正则表达式的作业,学员们都积极保质保量完成,马哥和51CTO学院经过层层筛选,最终评选出了5位学员的优秀作业. 口头表扬不实际,当然要来点给力的!此次评选为优秀作业的小伙伴每人可获得两项奖品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02b65A0.html" rel="bookmark" class="title">csdn markdown</a>
					<div>
						# Cmd Markdown 简明语法手册 标签: Cmd-Markdown --- ### 1. 斜体和粗体 使用 * 和 ** 表示斜体和粗体. 示例: 这是 *斜体*,这是 **粗体**. ## ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBAAgg4.html" rel="bookmark" class="title">easyui datagrid行合并</a>
					<div>
						easyui datagrid行合并 合并方法 /** * EasyUI DataGrid根据字段动态合并单元格 * 参数 tableID 要合并table的id * 参数 colList 要合并的列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418nWJ3.html" rel="bookmark" class="title">passwd</a>
					<div>
						linux下passwd命令设置修改用户密码 分类: linux 2011-10-09 09:43 20427人阅读 评论(0) 收藏 举报 linuxauthenticationunixuserlo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NzbqB4.html" rel="bookmark" class="title">仿百度搜索提示框效果</a>
					<div>
						&lt;!doctype html&gt;&lt;html&gt;&lt;head&gt; &lt;meta charset=&quot;UTF-8&quot;&gt; &lt;title&gt;百度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wyvzZM.html" rel="bookmark" class="title">OOP随笔</a>
					<div>
						父类为普通类: 内部可声明虚方法(virtual),并包含代码实现,子类中可以重写(override),也可以不重写直接用. 父类为(不可实例化的)抽象类: 可声明虚方法,同上. 也可以声明抽象方法( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvjEX3.html" rel="bookmark" class="title">安卓第十三天笔记-服务&lpar;Service&rpar;</a>
					<div>
						安卓第十三天笔记-服务(Service) Servcie服务 1.服务概念 服务 windows 服务没有界面,一直运行在后台, 运行在独立的一个进程里面 android 服务没有界面,一直运行在后台 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jXNbo4.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;Zhuang&period;Data&rdquo;轻型数据库访问框架（二）框架的入口DbAccessor对象</a>
					<div>
						目录: “Zhuang.Data”轻型数据库访问框架(一)开篇介绍 “Zhuang.Data”轻型数据库访问框架(二)框架的入口DbAccessor对象 先来看一段代码 DbAccessor dba  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38wKXg0.html" rel="bookmark" class="title">【转】Linux共享内存编程实例</a>
					<div>
						原文地址:http://blog.csdn.net/pcliuguangtao/article/details/6526119 ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ey1Qg0.html" rel="bookmark" class="title">PHP 算法</a>
					<div>
						1.首先来画个菱形玩玩,很多人学C时在书上都画过,咱们用PHP画下,画了一半. 思路:多少行for一次,然后在里面空格和星号for一次. ? 1 2 3 4 5 6 &lt;?php for($i=0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEl8RX4.html" rel="bookmark" class="title">UITableview优化</a>
					<div>
						说明: 开始只创建一部分可见的cell(已由Xcode实现) 在滚动的时候,先去缓存池中查找可用的cell,如果有,则取出使用 优化的两种方法 方法1:在创建cell时先去缓存池找是否有可用的cell ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e7pVb4.html" rel="bookmark" class="title">那些年我们一起追过的缓存写法&lpar;三&rpar;</a>
					<div>
						目录 一:分析设计 二:O(1)LRU实现 三:过期删除策略 四: 总结 一:分析设计 假设有个项目有一定并发量,要用到多级缓存,如下: 在实际设计一个内存缓存前,我们需要考虑的问题: 1:内存与Re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Ny1x63.html" rel="bookmark" class="title">windows 消息循环和窗口与线程关系</a>
					<div>
						/WinMain函数 int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXleoXM.html" rel="bookmark" class="title">noip推荐系列：遥控车&lbrack;字符串&plus;高精&plus;二分答案&rsqb;</a>
					<div>
						[问题描述] 平平带着韵韵来到了游乐园,看到了n辆漂亮的遥控车,每辆车上都有一个唯一的名字name[i].韵韵早就迫不及待地想玩名字是s的遥控车.可是韵韵毕竟还小,她想象的名字可能是一辆车名字的前缀( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1p7P3.html" rel="bookmark" class="title">站点搭建从零開始（七） WordPress站点的完好</a>
					<div>
						1.WordPress站点前后端经常使用语言简单介绍和执行过程 通常一个站点的整个构建过程中须要大量的技术支持,尤其是用到非常多种计算机语言.站点的构建主要分后端和前端两部分,后端代码在server上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME1RrXM.html" rel="bookmark" class="title">iOS 时间处理（转）</a>
					<div>
						NSDate NSDate对象用来表示一个具体的时间点. NSDate是一个类簇,我们所使用的NSDate对象,都是NSDate的私有子类的实体. NSDate存储的是GMT时间,使用的时候会根据 当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k6vZbM.html" rel="bookmark" class="title">onethink框架显示Access denied for user &amp;&num;39&semi;root&amp;&num;39&semi;&commat;&amp;&num;39&semi;localhost&amp;&num;39&semi; &lpar;using password&colon; NO&rpar;</a>
					<div>
						本地开发的时候使用的用户名是root,密码为空,它会生成两份.一份在Common/config.php里面,还有一份在Application\User\Conf/config.php 在linux环境 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QvyywM.html" rel="bookmark" class="title">读入a&comma;b当a&comma;b不同时为零时结束</a>
					<div>
						#define LOCAL #include&lt;map&gt; #include&lt;cstdio&gt; const int MAX_N=100; int a[MAX_N],b[MAX_N]; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDlYVeM.html" rel="bookmark" class="title">Altium Designer学习---如何进行SI仿真</a>
					<div>
						Altium designer 如何进行SI仿真. 1.仿真电路中需要至少一块集成电路: 2.器件的IBIS模型: 3.在规则中必须设定电源网络和地网络: 4.建立SI规则约束: 5.层堆栈必须设置正 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
